/*
 * Created on 15/lug/06
 *
 */
package portachiavi;

/**
 * Controllore del portachiavi
 * 
 * @author andrea
 * 
 */
public interface IController {

	/**
	 * Aggiunge un elemento al portachiavi
	 * 
	 * @return true se l'elemento è stato aggiunto
	 */
	public boolean addEntry();

	/**
	 * 
	 * 
	 */
	public void autoLoadPortachiavi();

	/**
	 * 
	 * 
	 */
	public void exit();

	/**
	 * 
	 * @return
	 */
	public boolean export2TextFile();

	/**
	 * Carica il portachiavi da disco rigido.
	 * 
	 * @return true se il portachiavi è stato caricato correttamente
	 */
	public boolean loadPortachiavi();

	/**
	 * Modifica un elemento del portafoglio
	 * 
	 * @return true se la modifica ha avuto successo
	 */
	public boolean modificaEntry();

	/**
	 * Stampa a video la lista degli identificatori delle entry del portafoglio
	 * 
	 */
	public void printEntryList();

	/**
	 * Rimouve un elemento dal portachiavi.
	 * 
	 * @return true se l'elemente è stato rimosso.
	 */
	public boolean removeEntry();

	/**
	 * Salva il portachiavi su disco rigido
	 * 
	 * @return true se il salvataggio è avvenuto correttamente.
	 */
	public boolean savePortachiavi();

	/**
	 * Cerca un elemento nel portachiavi.
	 * 
	 * @return true se l'elemento è presente
	 */
	public boolean searchEntry();

	/**
	 * Apre un pannello in cui inserire la nuova password per il portachiavi e
	 * la salva.
	 * 
	 */
	public void setFirstPassword();

	/**
	 * Apre un pannello in cui inserire la nuova password per il portachiavi e
	 * la salva.
	 * 
	 */
	public void setPassword();

}