/*
 * Created on 22/lug/06
 *
 */
package portachiavi;

import java.io.File;
import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;
import java.util.Set;

import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;

import portachiavi.exception.EntryNotFoundException;
import portachiavi.exception.KeyLoadingException;
import portachiavi.exception.KeySavingException;

public interface IPortachiavi {

	/**
	 * 
	 * @param id
	 * @param auth
	 * @return
	 */
	public boolean addEntry(String id, ILoginData auth);

	/**
	 * 
	 * @param textFile
	 * @throws IOException
	 */
	public void export2TextFile(File textFile) throws IOException;

	/**
	 * 
	 * @return
	 */
	public Set<String> getEntryList();

	/**
	 * 
	 * @return
	 */
	public HashMap<String, ILoginData> getList();

	/**
	 * 
	 * @param password
	 * @param objFile
	 * @param keyFile
	 * @throws IOException
	 * @throws ClassNotFoundException
	 * @throws InvalidKeyException
	 * @throws NoSuchAlgorithmException
	 * @throws KeyLoadingException
	 */
	public void loadList(char[] password, File objFile, File keyFile)
			throws IOException, ClassNotFoundException, InvalidKeyException,
			NoSuchAlgorithmException, KeyLoadingException;

	/**
	 * 
	 * @param id
	 * @throws EntryNotFoundException
	 */
	public void removeEntry(String id) throws EntryNotFoundException;

	/**
	 * 
	 * @param password
	 * @param objFile
	 * @param keyFile
	 * @throws NoSuchAlgorithmException
	 * @throws NoSuchPaddingException
	 * @throws InvalidKeyException
	 * @throws IllegalBlockSizeException
	 * @throws IOException
	 * @throws KeySavingException
	 */
	public void saveList(char[] password, File objFile, File keyFile)
			throws NoSuchAlgorithmException, NoSuchPaddingException,
			InvalidKeyException, IllegalBlockSizeException, IOException,
			KeySavingException;

	/**
	 * 
	 * @param id
	 * @return
	 * @throws EntryNotFoundException
	 */
	public ILoginData searchEntry(String id) throws EntryNotFoundException;

}