/*
 * Created on 13/lug/06
 *
 */
package portachiavi.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.SwingConstants;

public class DoublePasswordDialog extends JDialog implements KeyListener {

	private static final long serialVersionUID = 1L;

	private JButton jButton = null;

	private JPanel jContentPane = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabelIcon = null; // @jve:decl-index=0:visual-constraint=

	private JPanel jPanel = null; // @jve:decl-index=0:visual-constraint="3,17"

	private JPasswordField jPasswordField1 = null;

	private JPasswordField jPasswordField2 = null;

	private char[] password;

	// "279,165"

	/**
	 * @param owner
	 */
	public DoublePasswordDialog() {
		super();
		initialize();
	}

	private boolean equal(char[] a, char[] b) {
		if (a.length != b.length) {
			return false;
		}
		for (int i = 0; i < a.length; i++) {
			if (a[i] != b[i]) {
				return false;
			}
		}
		return true;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (equal(getJPasswordField1().getPassword(),
							getJPasswordField2().getPassword())) {
						password = getJPasswordField1().getPassword();
						setVisible(false);
						getJPasswordField1().setText("");
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJLabelIcon(), BorderLayout.WEST);
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jLabelIcon
	 * 
	 * @return javax.swing.JLabel
	 */
	private JLabel getJLabelIcon() {
		if (jLabelIcon == null) {
			jLabelIcon = new JLabel();
			jLabelIcon.setText("");
			jLabelIcon.setPreferredSize(new Dimension(50, 50));
			jLabelIcon.setHorizontalTextPosition(SwingConstants.CENTER);
			jLabelIcon.setHorizontalAlignment(SwingConstants.CENTER);
			jLabelIcon.setIcon(new ImageIcon(getClass().getResource(
					"/data/password.png")));
		}
		return jLabelIcon;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridy = 1;
			jLabel1 = new JLabel();
			jLabel1.setText("Ripeti la nuova password: ");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Inserisci la nuova password: ");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 2;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.gridx = 1;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(getJPasswordField1(), gridBagConstraints2);
			jPanel.add(getJButton(), gridBagConstraints5);
			jPanel.add(jLabel, gridBagConstraints);
			jPanel.add(getJPasswordField2(), gridBagConstraints1);
			jPanel.add(jLabel1, gridBagConstraints11);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPasswordField1
	 * 
	 * @return javax.swing.JPasswordField
	 */
	private JPasswordField getJPasswordField1() {
		if (jPasswordField1 == null) {
			jPasswordField1 = new JPasswordField();
			jPasswordField1.setColumns(20);
			jPasswordField1.addKeyListener(this);
		}
		return jPasswordField1;
	}

	/**
	 * This method initializes jPasswordField
	 * 
	 * @return javax.swing.JPasswordField
	 */
	private JPasswordField getJPasswordField2() {
		if (jPasswordField2 == null) {
			jPasswordField2 = new JPasswordField();
			jPasswordField2.setColumns(20);
			jPasswordField2.addKeyListener(this);
		}
		return jPasswordField2;
	}

	public char[] getPassword() {
		return password;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setTitle("Cambiare la password?");
		setContentPane(getJContentPane());
		setModal(true);
		Toolkit tk = Toolkit.getDefaultToolkit();
		int height = 100;
		int width = 500;
		int x = (tk.getScreenSize().width - width) / 2;
		int y = (tk.getScreenSize().height - height) / 2;
		this.setBounds(x, y, width, height);
	}

	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_ENTER) {
			if (equal(getJPasswordField1().getPassword(), getJPasswordField2()
					.getPassword())) {
				password = getJPasswordField1().getPassword();
				setVisible(false);
				getJPasswordField1().setText("");
			}
		}
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
	}

} // @jve:decl-index=0:visual-constraint="10,10"
