/*
 * Created on 14/lug/06
 *
 */
package portachiavi.gui;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class EntryDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private String id = ""; // @jve:decl-index=0:

	private JTextField idField = null;

	private JButton jButton = null;

	private JPanel jContentPane = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JPanel jPanel = null;

	private String password = ""; // @jve:decl-index=0:

	private JTextField passwordField = null;

	private JTextField userField = null;

	private String username = ""; // @jve:decl-index=0:

	/**
	 * 
	 * 
	 */
	public EntryDialog() {
		super();
		initialize();
	}

	/**
	 * 
	 * @param id
	 *            vecchio ID
	 * @param username
	 *            vecchio username
	 * @param password
	 *            vecchia password
	 */
	public EntryDialog(String id, String username, String password) {
		super();
		this.id = id;
		this.username = username;
		this.password = password;
		initialize();
	}

	public String getId() {
		return id;
	}

	/**
	 * This method initializes idField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getIdField() {
		if (idField == null) {
			idField = new JTextField(id);
			idField.setColumns(20);
		}
		return idField;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					id = getIdField().getText();
					username = getUserField().getText();
					password = getPasswordField().getText();
					setVisible(false);
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 3;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints5.gridy = 2;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.gridx = 1;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 2;
			jLabel2 = new JLabel();
			jLabel2.setText("Password:");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 1;
			jLabel1 = new JLabel();
			jLabel1.setText("Username:");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Identificatore:");
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(jLabel, gridBagConstraints);
			jPanel.add(getIdField(), gridBagConstraints1);
			jPanel.add(jLabel1, gridBagConstraints2);
			jPanel.add(getUserField(), gridBagConstraints3);
			jPanel.add(jLabel2, gridBagConstraints4);
			jPanel.add(getPasswordField(), gridBagConstraints5);
			jPanel.add(getJButton(), gridBagConstraints6);
		}
		return jPanel;
	}

	public String getPassword() {
		return password;
	}

	/**
	 * This method initializes passwordField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getPasswordField() {
		if (passwordField == null) {
			passwordField = new JTextField(password);
			passwordField.setColumns(20);
		}
		return passwordField;
	}

	/**
	 * This method initializes userField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getUserField() {
		if (userField == null) {
			userField = new JTextField(username);
			userField.setColumns(20);
		}
		return userField;
	}

	public String getUsername() {
		return username;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setContentPane(getJContentPane());
		setModal(true);
		pack();
		Toolkit tk = Toolkit.getDefaultToolkit();
		int height = getHeight();
		int width = getWidth();
		int x = (tk.getScreenSize().width - width) / 2;
		int y = (tk.getScreenSize().height - height) / 2;
		this.setBounds(x, y, width, height);
	}

}
