/*
 * Created on 13/lug/06
 *
 */
package portachiavi.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;

import portachiavi.IController;

public class PortachiaviFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private JMenuItem aboutMenuItem = null;

	private JMenuItem addMenuItem = null;

	private IController controller;

	private JMenu entryMenu = null;

	private JMenuItem exitMenuItem = null;

	private JMenuItem exportMenuItem = null; // @jve:decl-index=0:visual-

	private JMenu infoMenu = null;

	private JPanel jContentPane = null;

	private JMenuBar jJMenuBar = null;

	private JLabel jLabel = null; //@jve:decl-index=0:visual-constraint="709,405"

	private JMenuItem listMenuItem = null;

	private JList listViewer = null;

	private JMenuItem modifyMenuItem = null;

	private JMenuItem openMenuItem = null;

	private JMenuItem passwordMenuItem = null;

	private JMenu portachiaviMenu = null;

	private JMenuItem removeMenuItem = null;

	private JMenuItem saveMenuItem = null;

	private JMenuItem showMenuItem = null;

	private JTextField statusBar = null;

	// constraint="692,99"

	/**
	 * This is the default constructor
	 */
	public PortachiaviFrame(IController controller, JList listViewer) {
		super();
		this.controller = controller;
		this.listViewer = listViewer;
		initialize();
	}

	/**
	 * This method initializes aboutMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getAboutMenuItem() {
		if (aboutMenuItem == null) {
			aboutMenuItem = new JMenuItem();
			aboutMenuItem.setText("Informazioni");
			aboutMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/info.png")));
			aboutMenuItem
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							JOptionPane
									.showMessageDialog(
											null,
											"Portachiavi 1.2 beta\nAndrea Urbini 2009\nhttp://www.urbo.altervista.org",
											"Informazioni",
											JOptionPane.INFORMATION_MESSAGE,
											new ImageIcon(getClass()
													.getResource(
															"/data/info.png")));
						}
					});
		}
		return aboutMenuItem;
	}

	/**
	 * This method initializes addMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getAddMenuItem() {
		if (addMenuItem == null) {
			addMenuItem = new JMenuItem();
			addMenuItem.setText("Aggiungi una coppia username/password");
			addMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/add.png")));
			addMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (controller.addEntry()) {
						getStatusBar().setText("Entry aggiunta correttamente.");
					} else {
						getStatusBar().setText("Entry non aggiunta.");
					}
				}
			});
		}
		return addMenuItem;
	}

	/**
	 * This method initializes entryMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getEntryMenu() {
		if (entryMenu == null) {
			entryMenu = new JMenu();
			entryMenu.setText("Entry");
			entryMenu.add(getAddMenuItem());
			entryMenu.add(getRemoveMenuItem());
			entryMenu.add(getShowMenuItem());
			entryMenu.add(getModifyMenuItem());
			entryMenu.add(getListMenuItem());
		}
		return entryMenu;
	}

	/**
	 * This method initializes exitMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText("Esci dal programma");
			exitMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/exit.png")));
			exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					controller.exit();
				}
			});
		}
		return exitMenuItem;
	}

	/**
	 * This method initializes exportMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getExportMenuItem() {
		if (exportMenuItem == null) {
			exportMenuItem = new JMenuItem();
			exportMenuItem
					.setText("Esporta il portachiavi su un file di testo");
			exportMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/export.png")));
			exportMenuItem
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (controller.export2TextFile()) {
								getStatusBar().setText(
										"Portachiavi esportato correttamente.");
							} else {
								getStatusBar().setText(
										"Portachiavi non esportato.");
							}
						}
					});
		}
		return exportMenuItem;
	}

	/**
	 * This method initializes infoMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getInfoMenu() {
		if (infoMenu == null) {
			infoMenu = new JMenu();
			infoMenu.setText("?");
			infoMenu.add(getAboutMenuItem());
		}
		return infoMenu;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getStatusBar(), BorderLayout.SOUTH);
			jContentPane.add(getJLabel(), BorderLayout.NORTH);
			jContentPane.add(getListViewer(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getPortachiaviMenu());
			jJMenuBar.add(getEntryMenu());
			jJMenuBar.add(getInfoMenu());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new JLabel();
			jLabel.setText("Lista degli ID di tutte le entry nel portachiavi");
			jLabel.setVerticalTextPosition(SwingConstants.CENTER);
			jLabel.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel.setVerticalAlignment(SwingConstants.BOTTOM);
			jLabel.setPreferredSize(new Dimension(280, 30));
		}
		return jLabel;
	}

	/**
	 * This method initializes listMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getListMenuItem() {
		if (listMenuItem == null) {
			listMenuItem = new JMenuItem();
			listMenuItem
					.setText("Mostra gli ID di tutte le coppie username/password");
			listMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/refresh.png")));
			listMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					controller.printEntryList();
				}
			});
		}
		return listMenuItem;
	}

	public JList getListViewer() {
		return listViewer;
	}

	/**
	 * This method initializes modifyMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getModifyMenuItem() {
		if (modifyMenuItem == null) {
			modifyMenuItem = new JMenuItem();
			modifyMenuItem
					.setText("Modifica username e password della riga selezionata");
			modifyMenuItem.setMnemonic(KeyEvent.VK_UNDEFINED);
			modifyMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/modify.png")));
			modifyMenuItem
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (controller.modificaEntry()) {
								getStatusBar().setText(
										"Modifica avvenuta correttamente.");
							} else {
								getStatusBar()
										.setText("Modifica non avvenuta.");
							}
						}
					});
		}
		return modifyMenuItem;
	}

	/**
	 * This method initializes openMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getOpenMenuItem() {
		if (openMenuItem == null) {
			openMenuItem = new JMenuItem();
			openMenuItem.setText("Carica il portachiavi da disco");
			openMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
					Event.CTRL_MASK, true));
			openMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/open.png")));
			openMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (controller.loadPortachiavi()) {
						getStatusBar().setText(
								"Portachiavi caricato correttamente.");
					} else {
						getStatusBar().setText("Portachiavi non caricato.");
					}
				}
			});
		}
		return openMenuItem;
	}

	/**
	 * This method initializes passwordMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getPasswordMenuItem() {
		if (passwordMenuItem == null) {
			passwordMenuItem = new JMenuItem();
			passwordMenuItem.setText("Cambia la password del portachiavi");
			passwordMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/password.png")));
			passwordMenuItem
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							controller.setFirstPassword();
						}
					});
		}
		return passwordMenuItem;
	}

	/**
	 * This method initializes portachiaviMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getPortachiaviMenu() {
		if (portachiaviMenu == null) {
			portachiaviMenu = new JMenu();
			portachiaviMenu.setText("Portachiavi");
			portachiaviMenu.add(getOpenMenuItem());
			portachiaviMenu.add(getSaveMenuItem());
			portachiaviMenu.add(getExportMenuItem());
			portachiaviMenu.add(getPasswordMenuItem());
			portachiaviMenu.add(new JSeparator());
			portachiaviMenu.add(getExitMenuItem());
		}
		return portachiaviMenu;
	}

	/**
	 * This method initializes removeMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getRemoveMenuItem() {
		if (removeMenuItem == null) {
			removeMenuItem = new JMenuItem();
			removeMenuItem.setText("Elimina la riga selezionata");
			removeMenuItem.setAccelerator(KeyStroke.getKeyStroke(
					KeyEvent.VK_DELETE, Event.CTRL_MASK, true));
			removeMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/remove.png")));
			removeMenuItem
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (controller.removeEntry()) {
								getStatusBar().setText(
										"Rimozione della entry completata.");
							} else {
								getStatusBar().setText("Entry non rimossa.");
							}
						}
					});
		}
		return removeMenuItem;
	}

	/**
	 * This method initializes saveMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getSaveMenuItem() {
		if (saveMenuItem == null) {
			saveMenuItem = new JMenuItem();
			saveMenuItem.setText("Salva il portachiavi su disco");
			saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
					Event.CTRL_MASK, true));
			saveMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/save.png")));
			saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (controller.savePortachiavi()) {
						getStatusBar().setText(
								"Portachiavi salvato correttamente.");
					} else {
						getStatusBar().setText("Portachiavi non salvato.");
					}
				}
			});
		}
		return saveMenuItem;
	}

	/**
	 * This method initializes showMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getShowMenuItem() {
		if (showMenuItem == null) {
			showMenuItem = new JMenuItem();
			showMenuItem
					.setText("Visualizza username e password della riga selezionata");
			showMenuItem.setAccelerator(KeyStroke.getKeyStroke(
					KeyEvent.VK_ENTER, Event.CTRL_MASK, true));
			showMenuItem.setIcon(new ImageIcon(getClass().getResource(
					"/data/view.png")));
			showMenuItem.setActionCommand("");
			showMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (controller.searchEntry()) {
						getStatusBar().setText("Entry trovata.");
					} else {
						getStatusBar().setText("Entry non trovata.");
					}
				}
			});
		}
		return showMenuItem;
	}

	/**
	 * 
	 * @return
	 */
	private JTextField getStatusBar() {
		if (statusBar == null) {
			statusBar = new JTextField();
			statusBar.setEditable(false);
			statusBar.setForeground(Color.black);
			statusBar.setEnabled(true);
		}
		return statusBar;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setJMenuBar(getJJMenuBar());
		setContentPane(getJContentPane());
		setTitle("Portachiavi 1.2 beta");
		Toolkit tk = Toolkit.getDefaultToolkit();
		int height = 480;
		int width = 640;
		int x = (tk.getScreenSize().width - width) / 2;
		int y = (tk.getScreenSize().height - height) / 2;
		this.setSize(new Dimension(width, height));
		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				controller.exit();
			}
		});
		this.setLocation(x, y);
		listViewer.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					if (controller.searchEntry()) {
						getStatusBar().setText("Entry trovata.");
					} else {
						getStatusBar().setText("Entry non trovata.");
					}
				}
			}

		});
	}
} // @jve:decl-index=0:visual-constraint="10,10"
