/*
 * Created on 02/set/06
 *
 */
package portachiavi.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class ShowEntryDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private String id = null;

	private JTextField idField = null;

	private JButton jButton = null;

	private JPanel jContentPane = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private String password = null;

	private JTextField passwordField = null;

	private String username = null;

	private JTextField usernameField = null;

	/**
	 * @param owner
	 */
	public ShowEntryDialog(String id, String username, String password) {
		super();
		this.id = id;
		this.username = username;
		this.password = password;
		initialize();
	}

	/**
	 * This method initializes idField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getIdField() {
		if (idField == null) {
			idField = new JTextField(id);
			idField.setColumns(20);
			idField.setPreferredSize(new Dimension(224, 19));
			idField.setEditable(false);
		}
		return idField;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setVisible(false);
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 3;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints5.gridy = 2;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.gridx = 1;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 2;
			jLabel3 = new JLabel();
			jLabel3.setText("Password:");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 1;
			jLabel2 = new JLabel();
			jLabel2.setText("Username:");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("Identificatore:");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel1, gridBagConstraints);
			jContentPane.add(getIdField(), gridBagConstraints1);
			jContentPane.add(jLabel2, gridBagConstraints2);
			jContentPane.add(getUsernameField(), gridBagConstraints3);
			jContentPane.add(jLabel3, gridBagConstraints4);
			jContentPane.add(getPasswordField(), gridBagConstraints5);
			jContentPane.add(getJButton(), gridBagConstraints6);
		}
		return jContentPane;
	}

	/**
	 * This method initializes passwordField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getPasswordField() {
		if (passwordField == null) {
			passwordField = new JTextField(password);
			passwordField.setColumns(20);
			passwordField.setPreferredSize(new Dimension(224, 19));
			passwordField.setEditable(false);
		}
		return passwordField;
	}

	/**
	 * This method initializes usernameField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getUsernameField() {
		if (usernameField == null) {
			usernameField = new JTextField(username);
			usernameField.setColumns(20);
			usernameField.setPreferredSize(new Dimension(224, 19));
			usernameField.setEditable(false);
		}
		return usernameField;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setContentPane(getJContentPane());
		setModal(true);
		pack();
		Toolkit tk = Toolkit.getDefaultToolkit();
		int height = getHeight();
		int width = getWidth();
		int x = (tk.getScreenSize().width - width) / 2;
		int y = (tk.getScreenSize().height - height) / 2;
		this.setBounds(x, y, width, height);
	}

}
